package university;

public class University {

	public static final int INITIAL_ID = 10000;
	public static final int MAX_STUDENTS = 1000;
	public static final int INITIAL_CODE = 10;
	public static final int MAX_COURSES = 50;

	private String name;
	private String rector;
	private int nextID=INITIAL_ID;
	private Student[] students;
	private int nextCode=INITIAL_CODE;
	private Course[] courses;

	public University(String name){
		this.name = name;
		students = new Student[MAX_STUDENTS];
		courses = new Course[MAX_COURSES];
	}
	
	public String getName(){
		return name;
	}
	
	public void setRector(String first, String last){
		this.rector = first + " " + last;
	}
	
	public String getRector(){
		return rector;
	}
	
	public int enroll(String first, String last){
		Student s = new Student(this.nextID,first,last);
		students[this.nextID-INITIAL_ID] = s;
		return this.nextID++;
	}
	
	public String student(int id){
		return students[id-INITIAL_ID].toString();
	}
	
	public int activate(String title, String teacher){
		Course c = new Course(this.nextCode,title,teacher);
		courses[this.nextCode-INITIAL_CODE] = c;
		return this.nextCode++;
	}
	
	public String course(int code){
		return courses[code-INITIAL_CODE].toString();
	}
	
	public void register(int studentID, int courseCode){
		Course c = courses[courseCode-INITIAL_CODE];
		Student s = students[studentID-INITIAL_ID];
		
		c.registerAttendee(s);
		s.attendCourse(c);
		
	}
	
	public String listAttendees(int courseCode){
		Course c = courses[courseCode-INITIAL_CODE];

		return c.listAttendees();
	}

	public String studyPlan(int studentID){
		Student s = students[studentID-INITIAL_ID];
		return s.studyPlan();
	}
}
